
{ Written by Vadim Rumyantsev, 2:5030/48.4. }
{ Generic DELAY unit -- release  timeslices }
{ if under OS/2 2.0, Windows 3.0, DesqView, }
{ DoubleDOS and probably DOS 5.0 (?!), else }
{ do nothing.                               }
{ It is assumed that program  receives time }
{ quantums every day...  so, don't run this }
{ unit on slow systems!   ;-)               }
{ You may use this **without restrictions** }



UNIT USLDelay;

INTERFACE

procedure Delay (n : longint);

IMPLEMENTATION

uses Dos;

{ Define Seg0040 for backward compatibility with TP 4.0 .. TP 6.0 }

{$IFDEF MSDOS}
  const Seg0040 = $0040;
{$ENDIF}

var
  sys : (STANDARD, OS2, DESQVIEW, DOUBLEDOS);
  r   : Registers;

procedure Delay;

const
  TicksPerDay = 1572480;

var
  DelayQnt : longint;
  DoneTime : longint;
  DateFlag : boolean;
  nh, nl   : word;

begin

  if sys = OS2 then begin
    nh := n shr 16;
    nl := n and $FFFF;
    asm
      mov    dx, nh;
      mov    ax, nl;
      hlt;
      db     $35,$CA
    end;
    exit
  end;

  DoneTime := Mem [Seg0040:$006C];                   { What time is it?     }
  DelayQnt := round (n / 1000 * 18.2);               { How many ticks wait? }
  DateFlag := (DoneTime + DelayQnt) >= TicksPerDay;  { Skip midnight?       }
  DoneTime := (DoneTime + DelayQnt) mod TicksPerDay; { When we'll finish?   }

  while (DateFlag or (Mem [Seg0040:$006C] < DoneTime)) do

    if Mem [Seg0040:$006C] < DoneTime then   { A new day! }
      DateFlag := false;

    { Release timeslice }

    case sys of

      STANDARD:
        begin
          r.AX := $1680;
          Intr ($2F, r)
        end;

      DESQVIEW:
        begin
          r.AX := $1000;
          Intr ($15, r)
        end;

      DOUBLEDOS:
        begin
          r.AH := $EE;
          if DelayQnt > 767 then
            r.AL := $FF
          else
            r.AL := DelayQnt div 3;
          dec (DelayQnt, r.AL * 3);
          Intr ($21, r)
        end

    end

end;



BEGIN

  { Check for Novell NetWare to eliminate conflict with DoubleDOS detection }

  r.AX := $DC00;
  Intr ($21, r);

  if r.AL = 0 then begin

    { NetWare is not installed, so we can check for DoubleDOS }

    r.AX := $E400;
    Intr ($21, r);

    if r.AL <> 0 then begin   { Yes, DoubleDos }
      sys := DOUBLEDOS;
      exit
    end

  end;

  { Check for DesqView }

  r.AX := $1022;
  r.BX := $0000;
  Intr ($15, r);

  if r.BX <> 0 then begin   { Yes, DesqView or TopView }
    sys := DESQVIEW;
    exit
  end;

  { Check for OS/2 }

  r.AX := $4010;
  r.BX := $0000;
  Intr ($2F, r);

  if r.BH >= 20 then   { Yes, OS/2 2.0 }
    sys := OS2
  else
    sys := STANDARD    { No, make standard timeslice }

END.
